import { Component, Input, Output, EventEmitter, ViewChild } from '@angular/core';
import { ColumnFormat } from './column-info';
var AtGrid = (function () {
    function AtGrid() {
        /**Данные*/
        this.data = [];
        /**Колонки*/
        this.metaData = [];
        /**Количество строк на странице*/
        this.quRowOnPage = 10;
        /**Статический режим*/
        this.staticMode = true;
        /**Текущая страница*/
        this.currentPage = 0;
        /**Текущая страница*/
        this.imageSize = 100;
        /**Выделене какой-то позиции*/
        this.onSelect = new EventEmitter();
        /**Выделене какой-то позиции*/
        this.onLoad = new EventEmitter();
        /**Энум в компонет*/
        this.columnFormat = ColumnFormat;
    }
    /**Инит компонента*/
    AtGrid.prototype.ngOnInit = function () {
    };
    /**После загрузки вьюхи*/
    AtGrid.prototype.ngAfterViewChecked = function () {
    };
    /**Выделить строку*/
    AtGrid.prototype.selectRow = function (item) {
        this.onSelect.emit(item);
    };
    /**Первая страница*/
    AtGrid.prototype.firstPage = function () {
        this.currentPage = 0;
    };
    /**Первая страница*/
    AtGrid.prototype.lastPage = function () {
        this.currentPage = this.getQuPage() - 1;
    };
    /**Первая страница*/
    AtGrid.prototype.nextPage = function () {
        if (this.currentPage < (this.getQuPage() - 1)) {
            this.currentPage++;
        }
        else {
            this.currentPage = this.getQuPage() - 1;
        }
    };
    /**Первая страница*/
    AtGrid.prototype.prevPage = function () {
        if (this.currentPage > 0) {
            this.currentPage--;
        }
        else {
            this.currentPage = 0;
        }
    };
    /**Количество страниц*/
    AtGrid.prototype.getQuPage = function () {
        var result = Math.ceil(this.applyFilter().length / this.quRowOnPage);
        if (result <= 0) {
            result = 1;
        }
        return result;
    };
    /**Номер страницы от 1*/
    AtGrid.prototype.getHumanCurrentPage = function () {
        return this.currentPage + 1;
    };
    AtGrid.prototype.applyFilter = function () {
        var result = [];
        for (var _i = 0, _a = this.data; _i < _a.length; _i++) {
            var item = _a[_i];
            var checkFilter = true;
            for (var _b = 0, _c = this.metaData; _b < _c.length; _b++) {
                var column = _c[_b];
                if (column.filterInfo.value !== '') {
                    if (item[column.name] != null && item[column.name].toString().indexOf(column.filterInfo.value) !== -1) {
                        // Условие правильное
                    }
                    else {
                        checkFilter = false;
                        break;
                    }
                }
            }
            if (checkFilter) {
                result.push(item);
            }
        }
        return result;
    };
    /**Получить строки для страницы*/
    AtGrid.prototype.getRowForPage = function () {
        var index = 0;
        var result = [];
        for (var _i = 0, _a = this.applyFilter(); _i < _a.length; _i++) {
            var item = _a[_i];
            if (index >= this.currentPage * this.quRowOnPage && index < (this.currentPage + 1) * this.quRowOnPage) {
                result.push(item);
            }
            index++;
        }
        return result;
    };
    /**Фильтр изменен*/
    AtGrid.prototype.filterChanged = function (filter) {
        console.log(filter);
    };
    AtGrid.prototype.mouseOver = function (rowNum) {
        this.rowNumMouseOver = rowNum;
    };
    return AtGrid;
}());
export { AtGrid };
AtGrid.decorators = [
    { type: Component, args: [{
                moduleId: module.id,
                selector: 'at-grid',
                styles: ["\n    .uneven_row{background-color:#f9f9f9}.even_row{background-color:#ffffff}.uneven_row_mouse_over{background-color:#e9f9f9}.even_row_mouse_over{background-color:#e9f9f9}.base_row_tr{cursor:pointer}.base_row_td{padding:10px}.base_header_tr{cursor:pointer}.base_header_td{padding:10px}input,select{width:100%}li{padding-left:200px}td.last{width:1px;white-space:nowrap}.at-table{border-radius:10px}\n  "],
                template: "\n    <form name=\"form\" id=\"form\" #myForm=\"ngForm\">\n      <table width=\"100%\" style=\"width:100%\" border=\"1\" class=\"at-table\">\n        <thead>\n          <tr class=\"base_header_tr\">\n            <td *ngFor=\"let column of metaData\"\n                class=\"base_header_td\">\n              <b>{{column.comment}}</b>\n            </td>\n          </tr>\n          <tr>\n            <td *ngFor=\"let column of metaData\">\n              <input type=\"text\" [name]=\"column.name\" [id]=\"column.name\" [(ngModel)]=\"column.filterInfo.value\" (ngModelChange)=\"filterChanged($event)\">\n            </td>\n          </tr>\n        </thead>\n        <tbody>\n          <tr *ngFor=\"let item of getRowForPage(); let idx = index\"\n              [ngClass]=\"{ 'even_row': (idx % 2 == 0) && rowNumMouseOver != idx,\n               'uneven_row': (idx % 2 == 1) && rowNumMouseOver != idx,\n               'even_row_mouse_over': (idx % 2 == 0) && rowNumMouseOver == idx,\n               'uneven_row_mouse_over': (idx % 2 == 1) && rowNumMouseOver == idx\n               }\"\n              class=\"base_row_tr\"\n              (click)=\"selectRow(item)\"\n              (mouseleave)=\"mouseOver(null)\"\n              (mouseover)=\"mouseOver(idx)\"\n          >\n            <td *ngFor=\"let column of metaData\"\n                class=\"base_row_td\">\n              <div *ngIf=\"column.columnFormat == columnFormat.Number\" align=\"right\">\n                {{item[column.name]|number}}\n              </div>\n              <div *ngIf=\"column.columnFormat == columnFormat.Currency\" align=\"right\">\n                {{item[column.name]|number:'1.2-2'}}\n              </div>\n              <div *ngIf=\"column.columnFormat == columnFormat.Date\">\n                {{item[column.name]|date:'dd.MM.yyyy'}}\n              </div>\n              <div *ngIf=\"column.columnFormat == columnFormat.Default\">\n                {{item[column.name]}}\n              </div>\n              <div *ngIf=\"column.columnFormat == columnFormat.Boolean\">\n                <input type=\"checkbox\" [(ngModel)]=\"item[column.name]\" [id]=\"'col_' + column.name + '_' + idx\" [name]=\"'col_' + column.name + '_' + idx\"/>\n              </div>\n              <div *ngIf=\"column.columnFormat == columnFormat.Picture && item[column.name] != null\">\n                <img [width]=\"imageSize\" [height]=\"imageSize\" [src]=\"item[column.name] | safeHtml\" />\n              </div>\n            </td>\n          </tr>\n        </tbody>\n      </table>\n      <button (click)=\"firstPage()\"> << </button>\n      <button (click)=\"prevPage()\"> < </button>\n      {{getHumanCurrentPage()}} \u0438\u0437 {{getQuPage()}}\n      <button (click)=\"nextPage()\"> > </button>\n      <button (click)=\"lastPage()\"> >> </button>\n    </form>\n  "
            },] },
];
/** @nocollapse */
AtGrid.ctorParameters = function () { return []; };
AtGrid.propDecorators = {
    'data': [{ type: Input },],
    'metaData': [{ type: Input },],
    'quRowOnPage': [{ type: Input },],
    'staticMode': [{ type: Input },],
    'currentPage': [{ type: Input },],
    'imageSize': [{ type: Input },],
    'onSelect': [{ type: Output },],
    'form': [{ type: ViewChild, args: ['myForm',] },],
    'onLoad': [{ type: Output },],
};
//# sourceMappingURL=at-grid.js.map