(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@angular/platform-browser'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/forms', '@angular/platform-browser', '@angular/common'], factory) :
	(factory((global['at-grid'] = {}),global._angular_core,global._angular_forms,global._angular_platformBrowser,global._angular_common));
}(this, (function (exports,_angular_core,_angular_forms,_angular_platformBrowser,_angular_common) { 'use strict';

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}

var FilterInfo = (function () {
    function FilterInfo(value) {
        this.value = value;
    }
    return FilterInfo;
}());

var ColumnInfo = (function () {
    function ColumnInfo(name, comment, allowSort, filterInfo, columnFormat) {
        if (allowSort === void 0) { allowSort = true; }
        if (filterInfo === void 0) { filterInfo = new FilterInfo(''); }
        if (columnFormat === void 0) { columnFormat = exports.ColumnFormat.Default; }
        this.name = name;
        this.comment = comment;
        this.allowSort = allowSort;
        this.filterInfo = filterInfo;
        this.columnFormat = columnFormat;
    }
    return ColumnInfo;
}());

(function (ColumnFormat) {
    ColumnFormat[ColumnFormat["Date"] = 0] = "Date";
    ColumnFormat[ColumnFormat["Number"] = 1] = "Number";
    ColumnFormat[ColumnFormat["Currency"] = 2] = "Currency";
    ColumnFormat[ColumnFormat["Default"] = 3] = "Default";
    ColumnFormat[ColumnFormat["Boolean"] = 4] = "Boolean";
    ColumnFormat[ColumnFormat["Picture"] = 5] = "Picture";
})(exports.ColumnFormat || (exports.ColumnFormat = {}));

exports.AtGrid = (function () {
    function AtGrid() {
        /**Данные*/
        this.data = [];
        /**Колонки*/
        this.metaData = [];
        /**Количество строк на странице*/
        this.quRowOnPage = 10;
        /**Статический режим*/
        this.staticMode = true;
        /**Текущая страница*/
        this.currentPage = 0;
        /**Текущая страница*/
        this.imageSize = 100;
        /**Выделене какой-то позиции*/
        this.onSelect = new _angular_core.EventEmitter();
        /**Выделене какой-то позиции*/
        this.onLoad = new _angular_core.EventEmitter();
        /**Энум в компонет*/
        this.columnFormat = exports.ColumnFormat;
    }
    /**Инит компонента*/
    AtGrid.prototype.ngOnInit = function () {
    };
    /**После загрузки вьюхи*/
    AtGrid.prototype.ngAfterViewChecked = function () {
    };
    /**Выделить строку*/
    AtGrid.prototype.selectRow = function (item) {
        this.onSelect.emit(item);
    };
    /**Первая страница*/
    AtGrid.prototype.firstPage = function () {
        this.currentPage = 0;
    };
    /**Первая страница*/
    AtGrid.prototype.lastPage = function () {
        this.currentPage = this.getQuPage() - 1;
    };
    /**Первая страница*/
    AtGrid.prototype.nextPage = function () {
        if (this.currentPage < (this.getQuPage() - 1)) {
            this.currentPage++;
        }
        else {
            this.currentPage = this.getQuPage() - 1;
        }
    };
    /**Первая страница*/
    AtGrid.prototype.prevPage = function () {
        if (this.currentPage > 0) {
            this.currentPage--;
        }
        else {
            this.currentPage = 0;
        }
    };
    /**Количество страниц*/
    AtGrid.prototype.getQuPage = function () {
        var result = Math.ceil(this.applyFilter().length / this.quRowOnPage);
        if (result <= 0) {
            result = 1;
        }
        return result;
    };
    /**Номер страницы от 1*/
    AtGrid.prototype.getHumanCurrentPage = function () {
        return this.currentPage + 1;
    };
    AtGrid.prototype.applyFilter = function () {
        var result = [];
        for (var _i = 0, _a = this.data; _i < _a.length; _i++) {
            var item = _a[_i];
            var checkFilter = true;
            for (var _b = 0, _c = this.metaData; _b < _c.length; _b++) {
                var column = _c[_b];
                if (column.filterInfo.value !== '') {
                    if (item[column.name] != null && item[column.name].toString().indexOf(column.filterInfo.value) !== -1) {
                        // Условие правильное
                    }
                    else {
                        checkFilter = false;
                        break;
                    }
                }
            }
            if (checkFilter) {
                result.push(item);
            }
        }
        return result;
    };
    /**Получить строки для страницы*/
    AtGrid.prototype.getRowForPage = function () {
        var index = 0;
        var result = [];
        for (var _i = 0, _a = this.applyFilter(); _i < _a.length; _i++) {
            var item = _a[_i];
            if (index >= this.currentPage * this.quRowOnPage && index < (this.currentPage + 1) * this.quRowOnPage) {
                result.push(item);
            }
            index++;
        }
        return result;
    };
    /**Фильтр изменен*/
    AtGrid.prototype.filterChanged = function (filter) {
        console.log(filter);
    };
    AtGrid.prototype.mouseOver = function (rowNum) {
        this.rowNumMouseOver = rowNum;
    };
    return AtGrid;
}());
__decorate([
    _angular_core.Input(),
    __metadata("design:type", Object)
], exports.AtGrid.prototype, "data", void 0);
__decorate([
    _angular_core.Input(),
    __metadata("design:type", Array)
], exports.AtGrid.prototype, "metaData", void 0);
__decorate([
    _angular_core.Input(),
    __metadata("design:type", Number)
], exports.AtGrid.prototype, "quRowOnPage", void 0);
__decorate([
    _angular_core.Input(),
    __metadata("design:type", Boolean)
], exports.AtGrid.prototype, "staticMode", void 0);
__decorate([
    _angular_core.Input(),
    __metadata("design:type", Number)
], exports.AtGrid.prototype, "currentPage", void 0);
__decorate([
    _angular_core.Input(),
    __metadata("design:type", Number)
], exports.AtGrid.prototype, "imageSize", void 0);
__decorate([
    _angular_core.Output(),
    __metadata("design:type", Object)
], exports.AtGrid.prototype, "onSelect", void 0);
__decorate([
    _angular_core.ViewChild('myForm'),
    __metadata("design:type", typeof (_a = typeof _angular_forms.NgForm !== "undefined" && _angular_forms.NgForm) === "function" && _a || Object)
], exports.AtGrid.prototype, "form", void 0);
__decorate([
    _angular_core.Output(),
    __metadata("design:type", Object)
], exports.AtGrid.prototype, "onLoad", void 0);
exports.AtGrid = __decorate([
    _angular_core.Component({
        selector: 'at-grid',
        styles: [".uneven_row {\n  background-color: #f9f9f9; }\n\n.even_row {\n  background-color: #ffffff; }\n\n.uneven_row_mouse_over {\n  background-color: #e9f9f9; }\n\n.even_row_mouse_over {\n  background-color: #e9f9f9; }\n\n.base_row_tr {\n  cursor: pointer; }\n\n.base_row_td {\n  padding: 10px; }\n\n.base_header_tr {\n  cursor: pointer; }\n\n.base_header_td {\n  padding: 10px; }\n\ninput, select {\n  width: 100%; }\n\nli {\n  padding-left: 200px; }\n\ntd.last {\n  width: 1px;\n  white-space: nowrap; }\n\n.at-table {\n  border-radius: 10px; }\n"],
        template: "<form name=\"form\" id=\"form\" #myForm=\"ngForm\">\n  <table width=\"100%\" style=\"width:100%\" border=\"1\" class=\"at-table\">\n    <thead>\n      <tr class=\"base_header_tr\">\n        <td *ngFor=\"let column of metaData\"\n            class=\"base_header_td\">\n          <b>{{column.comment}}</b>\n        </td>\n      </tr>\n      <tr>\n        <td *ngFor=\"let column of metaData\">\n          <input type=\"text\" [name]=\"column.name\" [id]=\"column.name\" [(ngModel)]=\"column.filterInfo.value\" (ngModelChange)=\"filterChanged($event)\">\n        </td>\n      </tr>\n    </thead>\n    <tbody>\n      <tr *ngFor=\"let item of getRowForPage(); let idx = index\"\n          [ngClass]=\"{ 'even_row': (idx % 2 == 0) && rowNumMouseOver != idx,\n           'uneven_row': (idx % 2 == 1) && rowNumMouseOver != idx,\n           'even_row_mouse_over': (idx % 2 == 0) && rowNumMouseOver == idx,\n           'uneven_row_mouse_over': (idx % 2 == 1) && rowNumMouseOver == idx\n           }\"\n          class=\"base_row_tr\"\n          (click)=\"selectRow(item)\"\n          (mouseleave)=\"mouseOver(null)\"\n          (mouseover)=\"mouseOver(idx)\"\n      >\n        <td *ngFor=\"let column of metaData\"\n            class=\"base_row_td\">\n          <div *ngIf=\"column.columnFormat == columnFormat.Number\" align=\"right\">\n            {{item[column.name]|number}}\n          </div>\n          <div *ngIf=\"column.columnFormat == columnFormat.Currency\" align=\"right\">\n            {{item[column.name]|number:'1.2-2'}}\n          </div>\n          <div *ngIf=\"column.columnFormat == columnFormat.Date\">\n            {{item[column.name]|date:'dd.MM.yyyy'}}\n          </div>\n          <div *ngIf=\"column.columnFormat == columnFormat.Default\">\n            {{item[column.name]}}\n          </div>\n          <div *ngIf=\"column.columnFormat == columnFormat.Boolean\">\n            <input type=\"checkbox\" [(ngModel)]=\"item[column.name]\" [id]=\"'col_' + column.name + '_' + idx\" [name]=\"'col_' + column.name + '_' + idx\"/>\n          </div>\n          <div *ngIf=\"column.columnFormat == columnFormat.Picture && item[column.name] != null\">\n            <img [width]=\"imageSize\" [height]=\"imageSize\" [src]=\"item[column.name] | safeHtml\" />\n          </div>\n        </td>\n      </tr>\n    </tbody>\n  </table>\n  <button (click)=\"firstPage()\"> << </button>\n  <button (click)=\"prevPage()\"> < </button>\n  {{getHumanCurrentPage()}} \u0438\u0437 {{getQuPage()}}\n  <button (click)=\"nextPage()\"> > </button>\n  <button (click)=\"lastPage()\"> >> </button>\n</form>\n"
    })
], exports.AtGrid);
var _a;

var SafeHtml = (function () {
    function SafeHtml(sanitizer) {
        this.sanitizer = sanitizer;
    }
    SafeHtml.prototype.transform = function (html) {
        //return this.sanitizer.bypassSecurityTrustHtml(html);
        return this.sanitizer.bypassSecurityTrustResourceUrl(html);
    };
    return SafeHtml;
}());
SafeHtml = __decorate([
    _angular_core.Pipe({ name: 'safeHtml' }),
    __metadata("design:paramtypes", [typeof (_a$1 = typeof _angular_platformBrowser.DomSanitizer !== "undefined" && _angular_platformBrowser.DomSanitizer) === "function" && _a$1 || Object])
], SafeHtml);
var _a$1;

exports.AtGridModule = (function () {
    function AtGridModule() {
    }
    return AtGridModule;
}());
exports.AtGridModule = __decorate([
    _angular_core.NgModule({
        imports: [
            _angular_common.CommonModule,
            _angular_forms.FormsModule
        ],
        exports: [
            exports.AtGrid
        ],
        declarations: [
            exports.AtGrid,
            SafeHtml
        ]
    })
], exports.AtGridModule);

exports.FilterInfo = FilterInfo;
exports.ColumnInfo = ColumnInfo;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=at-grid.umd.js.map
